/*
 *  $Id: allgatherv.c,v 1.4 1993/11/12 12:30:51 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: allgatherv.c,v 1.4 1993/11/12 12:30:51 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_Allgatherv - 

@*/
int MPI_Allgatherv ( sendbuf, sendcnt, sendtype, 
		     recvbuf, displs, recvcnts, recvtype, comm )
void             *sendbuf;
int               sendcnt;
MPI_Datatype      sendtype;
void             *recvbuf;
int              *displs;
int              *recvcnts;
MPI_Datatype      recvtype;
MPI_Comm  comm;
{
  int size, rank, root;
  /* Check for invalid arguments */
  if ( (comm == (MPI_Comm)0) ||
       (comm->comm_type == MPIR_INTER) ) 
    return (MPI_SUCCESS); 
  
  /* Get the size of the communicator */
  MPI_Comm_size ( comm, &size );

  /* Do a gather for each process in the communicator */
  /* This is a sorry way to do this, but for now ... */
  for (root=0; root<size; root++)
    MPI_Gatherv(sendbuf,sendcnt,sendtype,recvbuf,displs,recvcnts,recvtype,root,comm);

  return (MPI_SUCCESS);
}
