/*
 *  $Id: attr_getval.c,v 1.5 1993/11/12 12:31:42 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

#ifndef MPIR_TRUE
#define MPIR_TRUE   1
#define MPIR_FALSE  0
#endif

/*@

MPI_Get_attr - retrieves attribute value by key

@*/
int MPI_Get_attr ( comm, keyval, attr_value, found )
MPI_Comm comm;
int keyval;
void **attr_value;
int *found;
{
  MPIR_HBT_node *attr;

  if (comm == (MPI_Comm)0) {
    (*found) = MPIR_FALSE;
    (*attr_value) = (void *)0;
  }
  else {
    MPIR_HBT_lookup(comm->attr_cache, keyval, &attr);
    if ( attr == (MPIR_HBT_node *)0 ) {
      (*found) = MPIR_FALSE;
      (*attr_value) = (void *)0; 
    }
    else {
      (*found) = MPIR_TRUE;
      (*attr_value) = attr->value;
    }
  }
  return(MPI_SUCCESS);
}



